package org.jhove2.module.format.warc;

import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import java.io.File;

import javax.annotation.Resource;

import org.jhove2.app.util.FeatureConfigurationUtil;
import org.jhove2.core.JHOVE2;
import org.jhove2.core.JHOVE2Exception;
import org.jhove2.core.source.FileSource;
import org.jhove2.persist.PersistenceManager;
import org.jhove2.persist.PersistenceManagerUtil;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(locations = {
        "classpath*:**/test-config.xml",
        "classpath*:**/filepaths-config.xml" })
public class ModuleTestBase {

    protected JHOVE2 JHOVE2;

    public JHOVE2 getJHOVE2() {
        return JHOVE2;
    }

    @Resource
    public void setJHOVE2(JHOVE2 jHOVE2) {
        JHOVE2 = jHOVE2;
    }

    protected FileSource getTestFileSource(String dirBasePathStr, String relativePathStr, String sourceDesc) {
        String exampleDirStr = null;
        PersistenceManager persistenceManager = null;
        FileSource fileSource = null;
        try {
            PersistenceManagerUtil.createPersistenceManagerFactory(JHOVE2.getConfigInfo());
            persistenceManager = PersistenceManagerUtil.getPersistenceManagerFactory().getInstance();
            persistenceManager.initialize();
            exampleDirStr = FeatureConfigurationUtil.getFilePathFromClasspath(dirBasePathStr, sourceDesc);
        }
        catch (JHOVE2Exception e) {
            fail("Could not locate base directory: " + dirBasePathStr + " " + e.getMessage());
        }
        try {
            File exampleDirFile = new File(exampleDirStr);
            assertTrue(exampleDirFile.exists());
            File testFile = new File(exampleDirFile, relativePathStr);
            assertTrue(testFile.exists());
            fileSource = (FileSource) JHOVE2.getSourceFactory().getSource(JHOVE2, testFile);
        }
        catch (Exception e) {
            fail("Could not locate FileSource: " + relativePathStr + " " + e.getMessage());
        }
        return fileSource;
    }

    /**
     * Test method for UTF8 Declaration information
     */
    @Test
    public void testTruth() {
        assertTrue(true);
    }

}
